#!/usr/bin/perl 
 use LWP::UserAgent  ;
 use JSON ;
 use strict;
 use warnings;
 use Getopt::Long;
 use Term::ANSIColor qw(:constants) ;
# Author:       Adnane RABIH
# USAGE:        adds a collectd configuration file for a router, and render it's grafana dashboard.       

	my $graphite_net = '46.21.206.168:8000' ; 
        my $collectd_router_conf_dir = '/usr/local/monitoring/snmp/etc/collectd.d';
        my $base_path = qw(/home/sdfrance/perl/net/desc/) ;
        my $dashboard_location = qw(/home/sdfrance/www/grafananet/app/dashboards/) ;

	my $eqx_routers_list = '/home/sdfrance/www/network/eqx_routers.html';
	my $orn_routers_list = '/home/sdfrance/www/network/orn_routers.html';
	my $itx_routers_list = '/home/sdfrance/www/network/itx_routers.html';
	my $th2_routers_list = '/home/sdfrance/www/network/th2_routers.html';

	my $routerid; 
	my $update= '0'  ;
	GetOptions ( 'name=s' => \$routerid, 'update' => \$update );
	chomp($routerid);

	# Using the LWP User Agent to parse KISS URLS 
	my @api_routerid =  split('\.', $routerid);
	my $api_routerid = $api_routerid[0].'_'.$api_routerid[1].'_'.$api_routerid[2].'_'.$api_routerid[3]; 

	print $api_routerid ; 	
	sub target_check {
		my $routerid = shift ;
		my @found_targets  = {};
		my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.' .  $routerid;
		my $query = $url . '*';
		my $ua = LWP::UserAgent->new;
			$ua->timeout(30);
			$ua->env_proxy;
		my $response = $ua->get( $query );
		my $json = $response->decoded_content;
		my $data = decode_json($json);
		my $name = $data->{'results'}->[0];
		return $name;
	}
	
	if (defined( target_check($api_routerid))) { print 'the router is in the API.' , "\n" ;} 
	else {print 'The router is not in the API.' , "\n"; exit;  }

	# my $collectd_router_conf_dir = '/usr/local/monitoring/snmp/etc/collectd.d';
	my $conf_file = $collectd_router_conf_dir . '/' . $routerid . '.conf' ;	
	if (! -e $conf_file) { print 'Error: can\'t locate ' ,  $conf_file , "\n" ; exit; }
	
	if($update != 1) {	
	{	
		local $^I='.bak'; # see perlvar(1)
		local @ARGV=$conf_file;
		while (<>) { s/Interval\s+\d+/Interval 300/; print ;}
		unlink $conf_file . '.bak' ;
	}
	print GREEN 'WARNING: '  , RESET ;	
	print RED 'collectd interval is set to 300 sec for this router you HAVE to restart collectd onece the script is done' , "\n" , RESET;
	}

	# my $base_path = qw(/home/sdfrance/perl/net/desc/) ;
	# my $dashboard_location = qw(/home/sdfrance/www/grafananet/app/dashboards/) ;

        sub uniq {
	        my %seen;
	        grep !$seen{$_}++, @_;
        }
  
           sub cards_extraction {
           # my $element = 'if_octets-*_';
           my $element = 'if_octets-*Ethernet';
           my $routerid = shift ; 
           my (@cards_result, @cards, @found_targets)  = {};
           my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.' . $routerid . '.snmp.' ;
               # foreach my $element (@elements) {
                        chomp ($element);
                        my $query = $url . $element . '*';
                        my $uaa = LWP::UserAgent->new;
                                $uaa->timeout(30);
                                $uaa->env_proxy;
                        my $response = $uaa->get( $query );
                        chomp $response ;
                        my $json = $response->decoded_content; 
                        my $data = decode_json($json);
                        chomp($json); 
                        my $name ;
                        my $item = 0 ;
                        while (defined ($name = $data->{'results'}->[$item] ) ) {
                                chomp($name) ;
                                push(@found_targets, $name);
                                $item++ ;
                        }
                #}
                 
                foreach my $target (@found_targets) {
                                chomp($target);
                                # print $target , "\n"  ;
                                if ($target =~ /.*\.snmp\.if_octets-(.*)_.*/) { my $x = $1 ; push(@cards_result, $x ) ; }
                }

                 foreach my $result (@cards_result) {
                           chomp($result);
                           # print $card , "\n" ; 
                           if ( $result  =~ /(.*)_.*/  ) { my $y = $1 ;  push(@cards, $y) ; }
                           else { push(@cards, $result) ; }
                 }


        my @cardsl = uniq(@cards);
        return @cardsl ; 
        }

	sub target_extraction {	
		my @elements = ( 'if_octets-');
		my ($routerid, $card) = @_ ; 
     		my @found_targets  = {};
		my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.' .  $routerid . '.snmp.' ;
		foreach my $element (@elements) {
			my $query = $url . $element . $card . '*';
			my $ua = LWP::UserAgent->new;
				$ua->timeout(30);
				$ua->env_proxy;
			my $response = $ua->get( $query );
			my $json = $response->decoded_content; 
			my $data = decode_json($json);
			my $name ;
			my $item = 0 ;
			while (defined ($name = $data->{'results'}->[$item] ) ) {
				chomp($name) ;
				push(@found_targets, $name);
				$item++ ;
			}
		}
		return @found_targets;
	}	
	
	my @cards = cards_extraction($api_routerid) ;
	my $card ; 
	foreach $card (@cards) { 
	if ($card =~ /hash/i or $card =~ /.*Ethernet\d+_.*/ 
		or $card =~ /NDE/ or $card =~ /span/i 
		or $card =~ /Te\d+.*/ or $card =~ /Gi\d+.*/ 
		or $card =~ /Control/ or $card =~ /vlan.*/i 
		or $card =~ /unrouted/ or $card =~ /EO.*/ or $card =~ /Port.*/) {next ;} 
	
	print $card , "\n" ;
	my $curent = $dashboard_location . $routerid . '-' . $card . '-desc.json';
        my $template_head = $base_path  .  qw(/header.json) ;
        open (OUTFIRST, ">$curent") || die $!;
        open (INFIRST, "$template_head") || die $!;
        while (<INFIRST>) {
                s/^.*(\"title\"\:\s+\")Monitoring(.*)/\t$1 $routerid-$card$2/;
                s/^.*(\"originalTitle\"\:\s+\")Monitoring(.*)/\t$1 $routerid-$card$2/;
                print OUTFIRST $_ ; }
        close INFIRST;
        close OUTFIRST;

	open (OUT, '>>', $curent) || die $!;
	
	my @found_targets = target_extraction($routerid, $card);	
	my $dash_id = 1 ;
	foreach my $target (@found_targets) {
	      chomp($target);
	      if ( $target =~ /if_octets/ )  { 	
		my @nics = split('\.', $target) ; 
		my $template = $base_path  .  qw(router_iftrafic.json);
	     	open (IN, '<' , $template) || die  $!;
	        	while (<IN>) {
				my $org_id = '"id": 6,';
				s/$org_id/"id": $dash_id,/;
				$dash_id++;
				my $org_target_rx = '"target": "collectd.x.snmp.if_octets-x.rx,"';
                                my $org_target_tx = '"target": "collectd.x.snmp.if_octets-x.tx,"';
				s/$org_target_rx/"target": "scale(collectd.$routerid.snmp.$nics[3].rx,8)"/ ;
                                s/$org_target_tx/"target": "scale(collectd.$routerid.snmp.$nics[3].tx,8)"/ ;
				my @title = split('-', $nics[3]); 
				s/"title": "TenGigabitEthernet2_4_trafic",/"title": "$title[1]_Trafic",/;
   				print OUT $_ ; 
				}
		close IN ;
		}
	}

	sub render {
		my ($template_name, $routerid) = @_ ;
		my $template = $base_path  .  $template_name ;
		open (IN, '<' , $template) || die  $!;
		while (<IN>) {
			s/^.*(\"target\"\:.*collectd)(\.x)\.(.*)\.(.*)/\t\t$1.$routerid.$3.$4/ ;
			print OUT $_ ;
		}
		close IN ;
	}
	
	foreach my $target (@found_targets) {
	        chomp($target);
	        #if ( $target =~ /uptime/ )  { render ('uptime.json', $routerid); last ; }
		 render ('uptime.json', $routerid); 
		last ;
	}

	close OUT ;

	my $template_foot = $base_path  .  qw(/footer.json) ;
	open (OUTL, ">>$curent") || die $!;
	open (INL, "$template_foot") || die $!;
	while (<INL>) { print OUTL $_ ; }
	close INL;
	close OUTL;
	
	my $uid = getpwnam 'sdfrance';
	my $gid = getgrnam 'users';
	chown $uid, $gid, $curent;
	
	# Check the existence of the router in the HTML lists 
	my $routers_list ;
	if ($routerid =~ m/eqx/) { $routers_list = $eqx_routers_list ;}
	elsif ($routerid =~ m/orn/) { $routers_list = $orn_routers_list;}
	elsif ($routerid =~ m/itx/) { $routers_list = $itx_routers_list;}
	elsif ($routerid =~ m/th2/) { $routers_list = $th2_routers_list;}
	else { $routers_list = $eqx_routers_list;}

	my $routerid_to_check = $routerid . "-" . $card ;
	chomp($routerid_to_check); 
	if ( check($routerid_to_check , $routers_list) != 0 ){
		print 'No match found. ' , $routerid_to_check , ' will be added to ' , $routers_list ,  " \n " ;
		my $link= "<a href=\"http://metronet.magic.fr/grafananet#/dashboard/file/$routerid_to_check.json\"target=\"_blank\">$routerid_to_check</a><br>" ;
		open (OUTLINKS, ">>$routers_list") || die "$!";
		print OUTLINKS "$link\n" ;
		close OUTLINKS;
	}

	sub check {
        my ($routerid_to_check, $routers_list) = @_ ;
        open (FILE, $routers_list);
        my @lines = <FILE> ;
        foreach (@lines) {
            if ( $_ =~ m/^.*$routerid_to_check.*$/) {
                print 'Router ', $routerid_to_check ,' already mentioned at line ', $. ,', it will not be added to ', $routers_list ,"\n" ;
                return  0;
                close FILE ;
                last;
            }
        }
        return 1;
        close FILE ;
    }
}
