#!/usr/bin/perl 
 use LWP::UserAgent  ;
 use JSON ;
 use strict;
 use warnings;
 use Getopt::Long;
 use Term::ANSIColor qw(:constants) ;
# Author:       Adnane RABIH
# USAGE:        adds a collectd configuration file for a switch, and render it's grafana dashboard. 


	my $graphite_net = '46.21.206.168:8000/';
        my $collectd_switch_conf_dir = '/usr/local/monitoring/snmp/etc/collectd.d';
	our $base_path = qw(/home/sdfrance/perl/net/) ;
	our $dashboard_location = qw(/home/sdfrance/www/grafananet/app/dashboards/) ;
	my $metronet = 'metronet.magic.fr';
	my $eqx_switchs_list = '/home/sdfrance/www/network/eqx_switches.html';
	my $orn_switchs_list = '/home/sdfrance/www/network/orn_switches.html';
	my $itx_switchs_list = '/home/sdfrance/www/network/itx_switches.html';
	my $thq_switchs_list = '/home/sdfrance/www/network/thq_switches.html';



	my $switchid; 
	my $update= '0'  ;
	GetOptions ( 'name=s' => \$switchid, 'update' => \$update );
	chomp($switchid);

	# Using the LWP User Agent to parse KISS URLS 
	my @api_switchid =  split('\.', $switchid);
	my $api_switchid = $api_switchid[0].'_'.$api_switchid[1].'_'.$api_switchid[2].'_'.$api_switchid[3]; 
	my $conf_switchid = $api_switchid[0].'_'.$api_switchid[1];

	print $api_switchid ; 	
	sub target_check {
		my $switchid = shift ;
		my @found_targets  = {};
		my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.' .  $switchid;
		my $query = $url . '*';
		my $ua = LWP::UserAgent->new;
			$ua->timeout(30);
			$ua->env_proxy;
		my $response = $ua->get( $query );
		my $json = $response->decoded_content;
		my $data = decode_json($json);
		my $name = $data->{'results'}->[0];
		return $name;
	}
	
	if (defined( target_check($api_switchid))) { print 'the switch is in the API.' , "\n" ;} 
	else {print 'The switch is not in the API.' , "\n"; exit;  }

	# my $collectd_switch_conf_dir = '/usr/local/monitoring/snmp/etc/collectd.d';
	my $conf_file = $collectd_switch_conf_dir . '/' . $conf_switchid . '.conf' ;	
	if (! -e $conf_file) { print 'Error: can\'t locate ' ,  $conf_file , "\n" ; exit; }
	
	if($update != 1) {	
	{	
		local $^I='.bak'; # see perlvar(1)
		local @ARGV=$conf_file;
		while (<>) { s/Interval\s+\d+/Interval 300/; print ;}
		unlink $conf_file . '.bak' ;
	}
	print RED 'WARNING: '  , RESET ;	
	print GREEN 'collectd interval is set to 300 sec for this switch you HAVE to restart collectd onece the script is done' , "\n" , RESET;
	}

# What comes next are instructive operations and hard-coded extractions
# to generate a Grafan Template for Network devices
# our $base_path = qw(/home/sdfrance/perl/net/) ;
# our $dashboard_location = qw(/home/sdfrance/www/grafananet/app/dashboards/) ;
our @elements = ( 'cpmCPUTotalMonIntervalValue', 'memory_*-Driver_text', 'memory_*-I_O', 'memory_*-Processor', 'if_octets-*', 'uptime');

sub render {
	my ($template_name, $switchid) = @_ ;
	my $template = $base_path  .  $template_name ;
	open (IN, '<' , $template) || die  $!;
	while (<IN>) {
		s/^.*(\"target\"\:.*collectd)(\.x)\.(.*)\.(.*)/\t\t$1.$switchid.$3.$4/ ;
		print OUT $_ ;
	}
	close IN ;
}

my $curent = $dashboard_location . $api_switchid . '.json';

my $template_head = $base_path  .  qw(/header.json) ;
open (OUTFIRST, ">$curent") || die $!;
open (INFIRST, "$template_head") || die $!;
while (<INFIRST>) { 
	s/^.*(\"title\"\:\s+\"Monitoring)(.*)/\t$1 $switchid$2/; 
	s/^.*(\"originalTitle\"\:\s+\"Monitoring)(.*)/\t$1 $switchid$2/; 
	print OUTFIRST $_ ; }
close INFIRST;
close OUTFIRST;

sub target_extraction {	
	my $switchid = shift ; 
	my @found_targets  = {};
	my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.' .  $switchid . '.snmp.' ;
	foreach my $element (@elements) {
		my $query = $url . $element . '*';
		my $ua = LWP::UserAgent->new;
			$ua->timeout(30);
			$ua->env_proxy;
		my $response = $ua->get( $query );
		my $json = $response->decoded_content; 
		my $data = decode_json($json);
		my $name ;
		my $item = 0 ;
		while (defined ($name = $data->{'results'}->[$item] ) ) {
			chomp($name) ;
			push(@found_targets, $name);
			$item++ ;
		}
	}
	return @found_targets;
}	

open (OUT, '>>', $curent) || die $!;
my @found_targets = target_extraction($api_switchid);
foreach my $target (@found_targets) {
	chomp($target);
	if ( $target =~ /memory_.*-Driver_text/ ) { render('memdriver.json', $api_switchid); last; } 
}

foreach my $target (@found_targets) {
	chomp($target);
	if ( $target =~ /memory_.*-I_O/ )  { render('memio.json', $api_switchid); last ; } 
}

foreach my $target (@found_targets) {
	chomp($target);
	if ( $target =~ /memory_.*-Processor/ )  { render('memproc.json', $api_switchid); last ; }
}

my $dash_id = 7 ; 	
foreach my $target (@found_targets) {
	chomp($target);
	if ( $target =~ /if_octets/ )  { 	
		my @nics = split('\.', $target) ; 
		my $template = $base_path  .  qw(iftrafic.json);
		open (IN, '<' , $template) || die  $!;
		while (<IN>) {
			my $org_id = '"id": 26,';
			s/$org_id/"id": $dash_id,/;
			$dash_id++;
			#s/^.*(\"target\"\:.*collectd)(\.x)\.(.*)\.(.*)\.(.*)/\t\t$1.$switchid.$3.$nics[3].$5/ ;
			s/^.*(\"target\"\:.*)(collectd)(\.x)\.(.*)\.(.*)\.(.*)",/\t\t$1scale($2.$api_switchid.$4.$nics[3].$6,8)",/ ;
			s/^.*(\"title\"\:\s+\")interface_trafic.*/\t\t$1$nics[3] Trafic",/;
			print OUT $_ ; 
		}
		close IN ;
	}
}

foreach my $target (@found_targets) {
	chomp($target);
	if ( $target =~ /uptime/ )  { render ('uptime.json', $api_switchid); last ; }
}

close OUT ;

my $template_foot = $base_path  .  qw(/footer.json) ;
open (OUTL, ">>$curent") || die $!;
open (INL, "$template_foot") || die $!;
while (<INL>) { print OUTL $_ ; }
close INL;
close OUTL;

my $uid = getpwnam 'sdfrance';
my $gid = getgrnam 'users';
chown $uid, $gid, $curent;

my $switchs_list ;
if ($switchid =~ m/eqx/) { $switchs_list = $eqx_switches_list ;}
if ($switchid =~ m/orn/) { $switchs_list = $orn_switches_list ;}
if ($switchid =~ m/itx/ or $switchid =~ m/ix3/ ) { $switchs_list = $itx_switches_list;}
if ($switchid =~ m/thq/) { $switchs_list = $thq_switches_list ;}

if ( check($api_switchid, $switchs_list) != 0 ){
	my @short_switchid = split('_', $api_switchid);
	print 'No match found. ' , $switchid , ' will be added to ' , $switchs_list ,  " \n " ;
	my $link= "<a href=\"http://" . $metronet . "/grafananet#/dashboard/file/$api_switchid.json\"target=\"_blank\">".
		$short_switchid[0].'.'.$short_switchid[1]."</a> <br>" ;
	open (OUTLINKS, ">>$switchs_list") || die "$!";
	print OUTLINKS "$link\n" ;
	close OUTLINKS;
}

# Check that the Server ID exists in the HTML LIST
sub check {
	my ($switchid_to_check, $switchs_list) = @_ ;
	open (FILE, $switchs_list);
	my @lines = <FILE> ;
	foreach (@lines) {
		if ( $_ =~ m/^.*$switchid_to_check.*$/) {
			print 'Switch ', $switchid_to_check ,' already mentioned at line ', $. ,', it will not be added to ', $switchs_list ,"\n" ;
			return  0;
			close FILE ;
			last;
		}
	}
	return 1;
	close FILE ;
}
#} # end of add_switch function.
