#!/usr/bin/perl
use strict ;
use warnings ; 
use LWP::UserAgent;
use JSON ;
use Data::Dumper;

# require  '/home/sdfrance/perl/perl_alert/alert.pl';

my @eqx_routersid = `curl -s https://kiss.magic.fr/network/eqx_routers.html | cut -d'>' -f2 | cut -d'<' -f1` ;
my @itx_routersid = `curl -s https://kiss.magic.fr/network/itx_routers.html | cut -d'>' -f2 | cut -d'<' -f1` ;
my @orn_routersid = `curl -s https://kiss.magic.fr/network/orn_routers.html | cut -d'>' -f2 | cut -d'<' -f1` ;
my @th2_routersid = `curl -s https://kiss.magic.fr/network/th2_routers.html | cut -d'>' -f2 | cut -d'<' -f1` ;
my $graphite_net = 'graphitenet.magic.fr:8000';

# global variables
my @routersid = (@eqx_routersid, @itx_routersid, @orn_routersid, @th2_routersid );
my (@routerid, $card, @ports,$port, $json, @event_args );
my $api_timeout = '30' ; # in seconds 
my $port_activity_time_sheck = '1760'; # in seconds 
my $max_router_possible_ports = '250' ;

# get all ports for every router card monitored.
foreach my $routerid (@routersid){
        chomp($routerid);
        my @routerall = split('-', $routerid);
        if (defined($routerall[0])) {$routerid = $routerall[0]};
        if (defined($routerall[0])) {$card = $routerall[1]};
	@ports = port_extraction($routerid, $card);
}

foreach $port (@ports) {
	my $status = status_check($port);
	chomp($status);
	print $port , "\n" ;
	if ($status eq 'active') { next ; }
	else { 
		@event_args = split('\.', $port) ;
		
		my $event_host = $event_args[1];
		my $event_service = $event_args[3];
		my $event_life = '60' ;
		my $event_stat = 'FAILURE' ;
		my $event_desc = 'the_router_' . $event_host . '_have_' . $event_service . '_down_from_more_than_' . $port_activity_time_sheck . 's.'  ;  
		my $event_metric = '' ;
		system("/usr/local/rvm/wrappers/ruby-2.1.2/ruby /home/sdfrance/www/rack/event.rb $event_host $event_life $event_service $event_stat $event_desc $event_metric " );  
		# alert($event_host, $event_service, $event_stat, $event_desc);
	}
}
# shecking the status of a port.
sub status_check {
	my $target = shift ;
	chomp $target ;
	my $url = 'http://' .  $graphite_net . '/render?target=' . $target . '.tx&format=json&from=-' . $port_activity_time_sheck  .'s';
       	$json = get_json($url);
	my @data = decode_json($json) ;

	my ($l1, $l2, $dp, $id, $count );
    	foreach $l1 (@data)
    		{
			foreach $l2 (@{$l1})
        		{
        		   $id =  'target=' . $l2->{'target'};
        			    foreach $dp (@{$l2->{'datapoints'}})
        			    {
                			my ($x,$y) ; 
                			$x =  Dumper($dp->[0])  ; 
                			# $x = $dp->[0] ;
					$y = $dp->[1];
					chomp($x);
                			if ($x) {  return 'active'; last;  }
            			   }
        		 }
    		}
}

# this function globalize json extraction for other function (essentially avoinding repeating our selves).
sub get_json {
	my $url = shift;
	my $ua = LWP::UserAgent->new;
		$ua->timeout($api_timeout);
        	$ua->env_proxy;
        my $response = $ua->get( $url );
        my $json = $response->decoded_content;
	return $json ;
	}

sub port_extraction {
        my ($routerid, $card ) = @_ ;
        my $url = 'http://' . $graphite_net . '/metrics/expand?query=collectd.'. $routerid . '.snmp.if_octets-' .   '*' ; #  $card . '*' ;
        my $json = get_json( $url );
        my $data = decode_json($json) ;
        for (my $i=0; $i <= $max_router_possible_ports; $i++) {
        	no warnings; 
	       my $name ;
		$name = $data->{'results'}->[$i];
		if ($name =~ /Te\d+.*/ or $name =~ /Gi\d+.*/  
			or $name =~ /Lo\d+.*/ or $name =~ /Loopback\d+.*/
			or $name =~ /span/i or $name =~ /EO.*/ 
			or $name =~ /CPP/ or $name =~ /NDE/
			or $name =~ /Gr\d+/  or $name =~ /Po\d+/) {next;}
		if (defined($name)) { push @ports, $name; } ;
        }
        return @ports ;
}
